// Code generated by protoc-gen-go. DO NOT EDIT.
// source: object.proto

/*
Package object is a generated protocol buffer package.

It is generated from these files:
	object.proto

It has these top-level messages:
	CleanResourcesRequest
	CleanResourcesResponse
	DataSource
	MinioConfig
	DataSourceEvent
	GetMinioConfigRequest
	GetMinioConfigResponse
	StorageStatsRequest
	StorageStatsResponse
	GetDataSourceConfigRequest
	GetDataSourceConfigResponse
*/
package object

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "github.com/mwitkow/go-proto-validators"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// Type of Gateway
type StorageType int32

const (
	StorageType_LOCAL StorageType = 0
	StorageType_S3    StorageType = 1
	StorageType_SMB   StorageType = 2
	StorageType_CELLS StorageType = 4
	StorageType_AZURE StorageType = 5
	StorageType_GCS   StorageType = 6
	StorageType_B2    StorageType = 7
	StorageType_MANTA StorageType = 8
	StorageType_SIA   StorageType = 9
)

var StorageType_name = map[int32]string{
	0: "LOCAL",
	1: "S3",
	2: "SMB",
	4: "CELLS",
	5: "AZURE",
	6: "GCS",
	7: "B2",
	8: "MANTA",
	9: "SIA",
}
var StorageType_value = map[string]int32{
	"LOCAL": 0,
	"S3":    1,
	"SMB":   2,
	"CELLS": 4,
	"AZURE": 5,
	"GCS":   6,
	"B2":    7,
	"MANTA": 8,
	"SIA":   9,
}

func (x StorageType) String() string {
	return proto.EnumName(StorageType_name, int32(x))
}
func (StorageType) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

// Type of Encryption
type EncryptionMode int32

const (
	EncryptionMode_CLEAR    EncryptionMode = 0
	EncryptionMode_MASTER   EncryptionMode = 1
	EncryptionMode_USER     EncryptionMode = 2
	EncryptionMode_USER_PWD EncryptionMode = 3
)

var EncryptionMode_name = map[int32]string{
	0: "CLEAR",
	1: "MASTER",
	2: "USER",
	3: "USER_PWD",
}
var EncryptionMode_value = map[string]int32{
	"CLEAR":    0,
	"MASTER":   1,
	"USER":     2,
	"USER_PWD": 3,
}

func (x EncryptionMode) String() string {
	return proto.EnumName(EncryptionMode_name, int32(x))
}
func (EncryptionMode) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

type DataSourceEvent_DSEventType int32

const (
	DataSourceEvent_CREATE   DataSourceEvent_DSEventType = 0
	DataSourceEvent_UPDATE   DataSourceEvent_DSEventType = 1
	DataSourceEvent_DELETE   DataSourceEvent_DSEventType = 2
	DataSourceEvent_ENABLED  DataSourceEvent_DSEventType = 3
	DataSourceEvent_DISABLED DataSourceEvent_DSEventType = 4
)

var DataSourceEvent_DSEventType_name = map[int32]string{
	0: "CREATE",
	1: "UPDATE",
	2: "DELETE",
	3: "ENABLED",
	4: "DISABLED",
}
var DataSourceEvent_DSEventType_value = map[string]int32{
	"CREATE":   0,
	"UPDATE":   1,
	"DELETE":   2,
	"ENABLED":  3,
	"DISABLED": 4,
}

func (x DataSourceEvent_DSEventType) String() string {
	return proto.EnumName(DataSourceEvent_DSEventType_name, int32(x))
}
func (DataSourceEvent_DSEventType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{4, 0}
}

type CleanResourcesRequest struct {
}

func (m *CleanResourcesRequest) Reset()                    { *m = CleanResourcesRequest{} }
func (m *CleanResourcesRequest) String() string            { return proto.CompactTextString(m) }
func (*CleanResourcesRequest) ProtoMessage()               {}
func (*CleanResourcesRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type CleanResourcesResponse struct {
	Success bool   `protobuf:"varint,1,opt,name=Success" json:"Success,omitempty"`
	Message string `protobuf:"bytes,2,opt,name=Message" json:"Message,omitempty"`
}

func (m *CleanResourcesResponse) Reset()                    { *m = CleanResourcesResponse{} }
func (m *CleanResourcesResponse) String() string            { return proto.CompactTextString(m) }
func (*CleanResourcesResponse) ProtoMessage()               {}
func (*CleanResourcesResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *CleanResourcesResponse) GetSuccess() bool {
	if m != nil {
		return m.Success
	}
	return false
}

func (m *CleanResourcesResponse) GetMessage() string {
	if m != nil {
		return m.Message
	}
	return ""
}

// DataSource Object description
type DataSource struct {
	// Name of the data source (max length 34)
	Name string `protobuf:"bytes,1,opt,name=Name" json:"Name,omitempty"`
	// Whether this data source is disabled or running
	Disabled bool `protobuf:"varint,2,opt,name=Disabled" json:"Disabled,omitempty"`
	// Type of underlying storage (LOCAL, S3, AZURE, GCS)
	StorageType StorageType `protobuf:"varint,3,opt,name=StorageType,enum=object.StorageType" json:"StorageType,omitempty"`
	// List of key values describing storage configuration
	StorageConfiguration map[string]string `protobuf:"bytes,4,rep,name=StorageConfiguration" json:"StorageConfiguration,omitempty" protobuf_key:"bytes,1,opt,name=key" protobuf_val:"bytes,2,opt,name=value"`
	// Corresponding objects service name (underlying s3 service)
	ObjectsServiceName string `protobuf:"bytes,18,opt,name=ObjectsServiceName" json:"ObjectsServiceName,omitempty"`
	// Corresponding objects service host
	ObjectsHost string `protobuf:"bytes,12,opt,name=ObjectsHost" json:"ObjectsHost,omitempty"`
	// Corresponding objects service port
	ObjectsPort int32 `protobuf:"varint,5,opt,name=ObjectsPort" json:"ObjectsPort,omitempty"`
	// Corresponding objects service connection type
	ObjectsSecure bool `protobuf:"varint,13,opt,name=ObjectsSecure" json:"ObjectsSecure,omitempty"`
	// Corresponding objects service bucket
	ObjectsBucket string `protobuf:"bytes,14,opt,name=ObjectsBucket" json:"ObjectsBucket,omitempty"`
	// Corresponding objects service base folder inside the bucket
	ObjectsBaseFolder string `protobuf:"bytes,15,opt,name=ObjectsBaseFolder" json:"ObjectsBaseFolder,omitempty"`
	// Corresponding objects service api key
	ApiKey string `protobuf:"bytes,16,opt,name=ApiKey" json:"ApiKey,omitempty"`
	// Corresponding objects service api secret
	ApiSecret string `protobuf:"bytes,17,opt,name=ApiSecret" json:"ApiSecret,omitempty"`
	// Peer address of the data source
	PeerAddress string `protobuf:"bytes,19,opt,name=PeerAddress" json:"PeerAddress,omitempty"`
	// Not implemented, whether to watch for underlying changes on the FS
	Watch bool `protobuf:"varint,6,opt,name=Watch" json:"Watch,omitempty"`
	// Type of encryption applied before sending data to storage
	EncryptionMode EncryptionMode `protobuf:"varint,7,opt,name=EncryptionMode,enum=object.EncryptionMode" json:"EncryptionMode,omitempty"`
	// Encryption key used for encrypting data
	EncryptionKey string `protobuf:"bytes,8,opt,name=EncryptionKey" json:"EncryptionKey,omitempty"`
	// Versioning policy describes how files are kept in the versioning queue
	VersioningPolicyName string `protobuf:"bytes,9,opt,name=VersioningPolicyName" json:"VersioningPolicyName,omitempty"`
	// Data Source creation date
	CreationDate int32 `protobuf:"varint,10,opt,name=CreationDate" json:"CreationDate,omitempty"`
	// Data Source last synchronization date
	LastSynchronizationDate int32 `protobuf:"varint,11,opt,name=LastSynchronizationDate" json:"LastSynchronizationDate,omitempty"`
}

func (m *DataSource) Reset()                    { *m = DataSource{} }
func (m *DataSource) String() string            { return proto.CompactTextString(m) }
func (*DataSource) ProtoMessage()               {}
func (*DataSource) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *DataSource) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *DataSource) GetDisabled() bool {
	if m != nil {
		return m.Disabled
	}
	return false
}

func (m *DataSource) GetStorageType() StorageType {
	if m != nil {
		return m.StorageType
	}
	return StorageType_LOCAL
}

func (m *DataSource) GetStorageConfiguration() map[string]string {
	if m != nil {
		return m.StorageConfiguration
	}
	return nil
}

func (m *DataSource) GetObjectsServiceName() string {
	if m != nil {
		return m.ObjectsServiceName
	}
	return ""
}

func (m *DataSource) GetObjectsHost() string {
	if m != nil {
		return m.ObjectsHost
	}
	return ""
}

func (m *DataSource) GetObjectsPort() int32 {
	if m != nil {
		return m.ObjectsPort
	}
	return 0
}

func (m *DataSource) GetObjectsSecure() bool {
	if m != nil {
		return m.ObjectsSecure
	}
	return false
}

func (m *DataSource) GetObjectsBucket() string {
	if m != nil {
		return m.ObjectsBucket
	}
	return ""
}

func (m *DataSource) GetObjectsBaseFolder() string {
	if m != nil {
		return m.ObjectsBaseFolder
	}
	return ""
}

func (m *DataSource) GetApiKey() string {
	if m != nil {
		return m.ApiKey
	}
	return ""
}

func (m *DataSource) GetApiSecret() string {
	if m != nil {
		return m.ApiSecret
	}
	return ""
}

func (m *DataSource) GetPeerAddress() string {
	if m != nil {
		return m.PeerAddress
	}
	return ""
}

func (m *DataSource) GetWatch() bool {
	if m != nil {
		return m.Watch
	}
	return false
}

func (m *DataSource) GetEncryptionMode() EncryptionMode {
	if m != nil {
		return m.EncryptionMode
	}
	return EncryptionMode_CLEAR
}

func (m *DataSource) GetEncryptionKey() string {
	if m != nil {
		return m.EncryptionKey
	}
	return ""
}

func (m *DataSource) GetVersioningPolicyName() string {
	if m != nil {
		return m.VersioningPolicyName
	}
	return ""
}

func (m *DataSource) GetCreationDate() int32 {
	if m != nil {
		return m.CreationDate
	}
	return 0
}

func (m *DataSource) GetLastSynchronizationDate() int32 {
	if m != nil {
		return m.LastSynchronizationDate
	}
	return 0
}

// Used a config storage for minio services
type MinioConfig struct {
	// Name of the object service
	Name string `protobuf:"bytes,1,opt,name=Name" json:"Name,omitempty"`
	// Underlying storage type (LOCAL, S3, AZURE, GCS)
	StorageType StorageType `protobuf:"varint,2,opt,name=StorageType,enum=object.StorageType" json:"StorageType,omitempty"`
	// Host where this minio is running
	RunningHost string `protobuf:"bytes,3,opt,name=RunningHost" json:"RunningHost,omitempty"`
	// Whether it is exposed with TLS or not
	RunningSecure bool `protobuf:"varint,4,opt,name=RunningSecure" json:"RunningSecure,omitempty"`
	// Port where this minio is bound
	RunningPort int32 `protobuf:"varint,5,opt,name=RunningPort" json:"RunningPort,omitempty"`
	// Api Key to access this object service
	ApiKey string `protobuf:"bytes,6,opt,name=ApiKey" json:"ApiKey,omitempty"`
	// Api Secret to access this object service
	ApiSecret string `protobuf:"bytes,7,opt,name=ApiSecret" json:"ApiSecret,omitempty"`
	// Url to get info about this object service
	EndpointUrl string `protobuf:"bytes,10,opt,name=EndpointUrl" json:"EndpointUrl,omitempty"`
	// Specific to Local storage type
	LocalFolder string `protobuf:"bytes,8,opt,name=LocalFolder" json:"LocalFolder,omitempty"`
	// Restrict this service to run on a given peer
	PeerAddress string `protobuf:"bytes,9,opt,name=PeerAddress" json:"PeerAddress,omitempty"`
	// Additional configs
	GatewayConfiguration map[string]string `protobuf:"bytes,11,rep,name=GatewayConfiguration" json:"GatewayConfiguration,omitempty" protobuf_key:"bytes,1,opt,name=key" protobuf_val:"bytes,2,opt,name=value"`
}

func (m *MinioConfig) Reset()                    { *m = MinioConfig{} }
func (m *MinioConfig) String() string            { return proto.CompactTextString(m) }
func (*MinioConfig) ProtoMessage()               {}
func (*MinioConfig) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

func (m *MinioConfig) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *MinioConfig) GetStorageType() StorageType {
	if m != nil {
		return m.StorageType
	}
	return StorageType_LOCAL
}

func (m *MinioConfig) GetRunningHost() string {
	if m != nil {
		return m.RunningHost
	}
	return ""
}

func (m *MinioConfig) GetRunningSecure() bool {
	if m != nil {
		return m.RunningSecure
	}
	return false
}

func (m *MinioConfig) GetRunningPort() int32 {
	if m != nil {
		return m.RunningPort
	}
	return 0
}

func (m *MinioConfig) GetApiKey() string {
	if m != nil {
		return m.ApiKey
	}
	return ""
}

func (m *MinioConfig) GetApiSecret() string {
	if m != nil {
		return m.ApiSecret
	}
	return ""
}

func (m *MinioConfig) GetEndpointUrl() string {
	if m != nil {
		return m.EndpointUrl
	}
	return ""
}

func (m *MinioConfig) GetLocalFolder() string {
	if m != nil {
		return m.LocalFolder
	}
	return ""
}

func (m *MinioConfig) GetPeerAddress() string {
	if m != nil {
		return m.PeerAddress
	}
	return ""
}

func (m *MinioConfig) GetGatewayConfiguration() map[string]string {
	if m != nil {
		return m.GatewayConfiguration
	}
	return nil
}

// Used to dispatch some specific events
// accross services
type DataSourceEvent struct {
	Type   DataSourceEvent_DSEventType `protobuf:"varint,1,opt,name=Type,enum=object.DataSourceEvent_DSEventType" json:"Type,omitempty"`
	Name   string                      `protobuf:"bytes,2,opt,name=Name" json:"Name,omitempty"`
	Config *DataSource                 `protobuf:"bytes,3,opt,name=Config" json:"Config,omitempty"`
}

func (m *DataSourceEvent) Reset()                    { *m = DataSourceEvent{} }
func (m *DataSourceEvent) String() string            { return proto.CompactTextString(m) }
func (*DataSourceEvent) ProtoMessage()               {}
func (*DataSourceEvent) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4} }

func (m *DataSourceEvent) GetType() DataSourceEvent_DSEventType {
	if m != nil {
		return m.Type
	}
	return DataSourceEvent_CREATE
}

func (m *DataSourceEvent) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *DataSourceEvent) GetConfig() *DataSource {
	if m != nil {
		return m.Config
	}
	return nil
}

type GetMinioConfigRequest struct {
}

func (m *GetMinioConfigRequest) Reset()                    { *m = GetMinioConfigRequest{} }
func (m *GetMinioConfigRequest) String() string            { return proto.CompactTextString(m) }
func (*GetMinioConfigRequest) ProtoMessage()               {}
func (*GetMinioConfigRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{5} }

type GetMinioConfigResponse struct {
	MinioConfig *MinioConfig `protobuf:"bytes,1,opt,name=MinioConfig" json:"MinioConfig,omitempty"`
}

func (m *GetMinioConfigResponse) Reset()                    { *m = GetMinioConfigResponse{} }
func (m *GetMinioConfigResponse) String() string            { return proto.CompactTextString(m) }
func (*GetMinioConfigResponse) ProtoMessage()               {}
func (*GetMinioConfigResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{6} }

func (m *GetMinioConfigResponse) GetMinioConfig() *MinioConfig {
	if m != nil {
		return m.MinioConfig
	}
	return nil
}

type StorageStatsRequest struct {
}

func (m *StorageStatsRequest) Reset()                    { *m = StorageStatsRequest{} }
func (m *StorageStatsRequest) String() string            { return proto.CompactTextString(m) }
func (*StorageStatsRequest) ProtoMessage()               {}
func (*StorageStatsRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{7} }

type StorageStatsResponse struct {
	Stats map[string]string `protobuf:"bytes,1,rep,name=Stats" json:"Stats,omitempty" protobuf_key:"bytes,1,opt,name=key" protobuf_val:"bytes,2,opt,name=value"`
}

func (m *StorageStatsResponse) Reset()                    { *m = StorageStatsResponse{} }
func (m *StorageStatsResponse) String() string            { return proto.CompactTextString(m) }
func (*StorageStatsResponse) ProtoMessage()               {}
func (*StorageStatsResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{8} }

func (m *StorageStatsResponse) GetStats() map[string]string {
	if m != nil {
		return m.Stats
	}
	return nil
}

type GetDataSourceConfigRequest struct {
}

func (m *GetDataSourceConfigRequest) Reset()                    { *m = GetDataSourceConfigRequest{} }
func (m *GetDataSourceConfigRequest) String() string            { return proto.CompactTextString(m) }
func (*GetDataSourceConfigRequest) ProtoMessage()               {}
func (*GetDataSourceConfigRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{9} }

type GetDataSourceConfigResponse struct {
	DataSource *DataSource `protobuf:"bytes,1,opt,name=DataSource" json:"DataSource,omitempty"`
}

func (m *GetDataSourceConfigResponse) Reset()                    { *m = GetDataSourceConfigResponse{} }
func (m *GetDataSourceConfigResponse) String() string            { return proto.CompactTextString(m) }
func (*GetDataSourceConfigResponse) ProtoMessage()               {}
func (*GetDataSourceConfigResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{10} }

func (m *GetDataSourceConfigResponse) GetDataSource() *DataSource {
	if m != nil {
		return m.DataSource
	}
	return nil
}

func init() {
	proto.RegisterType((*CleanResourcesRequest)(nil), "object.CleanResourcesRequest")
	proto.RegisterType((*CleanResourcesResponse)(nil), "object.CleanResourcesResponse")
	proto.RegisterType((*DataSource)(nil), "object.DataSource")
	proto.RegisterType((*MinioConfig)(nil), "object.MinioConfig")
	proto.RegisterType((*DataSourceEvent)(nil), "object.DataSourceEvent")
	proto.RegisterType((*GetMinioConfigRequest)(nil), "object.GetMinioConfigRequest")
	proto.RegisterType((*GetMinioConfigResponse)(nil), "object.GetMinioConfigResponse")
	proto.RegisterType((*StorageStatsRequest)(nil), "object.StorageStatsRequest")
	proto.RegisterType((*StorageStatsResponse)(nil), "object.StorageStatsResponse")
	proto.RegisterType((*GetDataSourceConfigRequest)(nil), "object.GetDataSourceConfigRequest")
	proto.RegisterType((*GetDataSourceConfigResponse)(nil), "object.GetDataSourceConfigResponse")
	proto.RegisterEnum("object.StorageType", StorageType_name, StorageType_value)
	proto.RegisterEnum("object.EncryptionMode", EncryptionMode_name, EncryptionMode_value)
	proto.RegisterEnum("object.DataSourceEvent_DSEventType", DataSourceEvent_DSEventType_name, DataSourceEvent_DSEventType_value)
}

func init() { proto.RegisterFile("object.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 1109 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x56, 0xdd, 0x6e, 0xdb, 0x36,
	0x14, 0x8e, 0xfc, 0x23, 0xdb, 0x47, 0x69, 0xa2, 0x32, 0x69, 0xa2, 0xb9, 0xd9, 0x66, 0xa8, 0x03,
	0x16, 0x04, 0x8d, 0x03, 0xb8, 0xe8, 0x16, 0x0c, 0xd8, 0x06, 0xd9, 0xd6, 0xb2, 0xa2, 0x72, 0x92,
	0x4a, 0xc9, 0x0a, 0x0c, 0x18, 0x56, 0x45, 0x66, 0x1d, 0x2d, 0x8e, 0xe8, 0x49, 0xb4, 0x53, 0xef,
	0x11, 0x76, 0xb3, 0x67, 0xd9, 0xdb, 0xec, 0x6e, 0xc0, 0x1e, 0x63, 0x57, 0x03, 0x29, 0xc9, 0xa2,
	0x1c, 0xb9, 0x58, 0xaf, 0xc4, 0xf3, 0x9d, 0x8f, 0x47, 0xe4, 0x39, 0xdf, 0x21, 0x09, 0xeb, 0xe4,
	0xea, 0x17, 0xec, 0xd1, 0xf6, 0x24, 0x24, 0x94, 0x20, 0x39, 0xb6, 0x9a, 0x5f, 0x8c, 0x7c, 0x7a,
	0x3d, 0xbd, 0x6a, 0x7b, 0xe4, 0xf6, 0xe8, 0xf6, 0xce, 0xa7, 0x37, 0xe4, 0xee, 0x68, 0x44, 0x0e,
	0x39, 0xe9, 0x70, 0xe6, 0x8e, 0xfd, 0xa1, 0x4b, 0x49, 0x18, 0x1d, 0x2d, 0x86, 0xf1, 0x7c, 0x7d,
	0x17, 0x1e, 0xf5, 0xc6, 0xd8, 0x0d, 0x6c, 0x1c, 0x91, 0x69, 0xe8, 0xe1, 0xc8, 0xc6, 0xbf, 0x4e,
	0x71, 0x44, 0x75, 0x0b, 0x76, 0x96, 0x1d, 0xd1, 0x84, 0x04, 0x11, 0x46, 0x1a, 0xd4, 0x9c, 0xa9,
	0xe7, 0xe1, 0x28, 0xd2, 0xa4, 0x96, 0xb4, 0x5f, 0xb7, 0x53, 0x93, 0x79, 0x06, 0x38, 0x8a, 0xdc,
	0x11, 0xd6, 0x4a, 0x2d, 0x69, 0xbf, 0x61, 0xa7, 0xa6, 0xfe, 0xaf, 0x0c, 0xd0, 0x77, 0xa9, 0xeb,
	0xf0, 0x58, 0xa8, 0x09, 0x95, 0x53, 0xf7, 0x16, 0xf3, 0xf9, 0x8d, 0xae, 0xfc, 0xcf, 0xdf, 0x9f,
	0x96, 0xde, 0xe9, 0x36, 0xc7, 0x50, 0x13, 0xea, 0x7d, 0x3f, 0x72, 0xaf, 0xc6, 0x78, 0xc8, 0xa3,
	0xd4, 0xed, 0x85, 0x8d, 0x9e, 0x83, 0xe2, 0x50, 0x12, 0xba, 0x23, 0x7c, 0x31, 0x9f, 0x60, 0xad,
	0xdc, 0x92, 0xf6, 0x37, 0x3a, 0x5b, 0xed, 0x24, 0x23, 0x82, 0xcb, 0x16, 0x79, 0xe8, 0x0d, 0x6c,
	0x27, 0x66, 0x8f, 0x04, 0x6f, 0xfd, 0xd1, 0x34, 0x74, 0xa9, 0x4f, 0x02, 0xad, 0xd2, 0x2a, 0xef,
	0x2b, 0x9d, 0xa7, 0xe9, 0xfc, 0x6c, 0x81, 0xed, 0x22, 0xba, 0x19, 0xd0, 0x70, 0x6e, 0x17, 0x46,
	0x42, 0x6d, 0x40, 0x67, 0x3c, 0x48, 0xe4, 0xe0, 0x70, 0xe6, 0x7b, 0x98, 0x6f, 0x0f, 0xf1, 0x24,
	0x14, 0x78, 0x50, 0x0b, 0x94, 0x04, 0xfd, 0x9e, 0x44, 0x54, 0x5b, 0xe7, 0x44, 0x11, 0x12, 0x18,
	0xe7, 0x24, 0xa4, 0x5a, 0xb5, 0x25, 0xed, 0x57, 0x6d, 0x11, 0x42, 0x9f, 0xc1, 0x83, 0x45, 0x64,
	0x6f, 0x1a, 0x62, 0xed, 0x01, 0xcf, 0x56, 0x1e, 0x14, 0x58, 0xdd, 0xa9, 0x77, 0x83, 0xa9, 0xb6,
	0xc1, 0xff, 0x95, 0x07, 0xd1, 0x53, 0x78, 0x98, 0x02, 0x6e, 0x84, 0xbf, 0x23, 0xe3, 0x21, 0x0e,
	0xb5, 0x4d, 0xce, 0xbc, 0xef, 0x40, 0x3b, 0x20, 0x1b, 0x13, 0xff, 0x25, 0x9e, 0x6b, 0x2a, 0xa7,
	0x24, 0x16, 0xda, 0x83, 0x86, 0x31, 0xf1, 0x1d, 0xec, 0x85, 0x98, 0x6a, 0x0f, 0xb9, 0x2b, 0x03,
	0xd8, 0x8e, 0xce, 0x31, 0x0e, 0x8d, 0xe1, 0x30, 0x64, 0xda, 0xd9, 0x8a, 0xf7, 0x2c, 0x40, 0x68,
	0x1b, 0xaa, 0xaf, 0x5d, 0xea, 0x5d, 0x6b, 0x32, 0xdf, 0x49, 0x6c, 0xa0, 0x6f, 0x60, 0xc3, 0x0c,
	0xbc, 0x70, 0x3e, 0x61, 0x99, 0x1e, 0x90, 0x21, 0xd6, 0x6a, 0xbc, 0xee, 0x3b, 0x69, 0xdd, 0xf2,
	0x5e, 0x7b, 0x89, 0xcd, 0x32, 0x90, 0x21, 0x6c, 0xd1, 0xf5, 0x38, 0x03, 0x39, 0x10, 0x75, 0x60,
	0xfb, 0x07, 0x1c, 0x46, 0x3e, 0x09, 0xfc, 0x60, 0x74, 0x4e, 0xc6, 0xbe, 0x37, 0xe7, 0x35, 0x6c,
	0x70, 0x72, 0xa1, 0x0f, 0xe9, 0xb0, 0xde, 0x0b, 0x31, 0x57, 0x40, 0xdf, 0xa5, 0x58, 0x03, 0x5e,
	0xa4, 0x1c, 0x86, 0x8e, 0x61, 0xd7, 0x72, 0x23, 0xea, 0xcc, 0x03, 0xef, 0x3a, 0x24, 0x81, 0xff,
	0x5b, 0x46, 0x57, 0x38, 0x7d, 0x95, 0xbb, 0x79, 0x02, 0x1f, 0xad, 0x94, 0x21, 0x52, 0xa1, 0x7c,
	0x83, 0xe7, 0x71, 0x03, 0xd9, 0x6c, 0xc8, 0x92, 0x37, 0x73, 0xc7, 0xd3, 0xb4, 0xf5, 0x62, 0xe3,
	0xab, 0xd2, 0xb1, 0xa4, 0xff, 0x5e, 0x01, 0x65, 0xe0, 0x07, 0x3e, 0x89, 0xe3, 0x20, 0x24, 0x76,
	0x5f, 0xd2, 0x75, 0x4b, 0x9d, 0x55, 0xfa, 0x9f, 0x9d, 0xd5, 0x02, 0xc5, 0x9e, 0x06, 0x2c, 0x2d,
	0x5c, 0xc7, 0xe5, 0xb8, 0xa6, 0x02, 0xc4, 0xb2, 0x9f, 0x98, 0x89, 0x4a, 0x2b, 0xb1, 0x4a, 0x73,
	0xa0, 0x10, 0x47, 0x54, 0xbb, 0x00, 0x09, 0x9a, 0x93, 0x57, 0x6b, 0xae, 0x56, 0xa0, 0x39, 0x33,
	0x18, 0x4e, 0x88, 0x1f, 0xd0, 0xcb, 0x70, 0xcc, 0x0b, 0xd4, 0xb0, 0x45, 0x88, 0x31, 0x2c, 0xe2,
	0xb9, 0xe3, 0x44, 0xf3, 0xb1, 0x36, 0x44, 0x68, 0x59, 0xb7, 0x8d, 0xfb, 0xba, 0x75, 0x61, 0xfb,
	0xc4, 0xa5, 0xf8, 0xce, 0x9d, 0xe7, 0xcf, 0x17, 0x85, 0x9f, 0x2f, 0x87, 0x69, 0x16, 0x85, 0x1a,
	0xb4, 0x8b, 0xf8, 0xc9, 0x01, 0x53, 0xe4, 0x62, 0x62, 0x58, 0x39, 0xe5, 0x83, 0xc4, 0xf0, 0x97,
	0x04, 0x9b, 0xd9, 0x41, 0x67, 0xce, 0x70, 0x40, 0xd1, 0x97, 0x50, 0xe1, 0x55, 0x97, 0x78, 0xd5,
	0x9f, 0xdc, 0x3f, 0x0f, 0x39, 0xad, 0xdd, 0x77, 0xf8, 0x97, 0xab, 0x80, 0x4f, 0x58, 0x28, 0xa9,
	0x24, 0x28, 0xe9, 0x00, 0xe4, 0x78, 0x89, 0x5c, 0x0d, 0x4a, 0x07, 0xdd, 0x0f, 0x67, 0x27, 0x0c,
	0xdd, 0x02, 0x45, 0x08, 0x8a, 0x00, 0xe4, 0x9e, 0x6d, 0x1a, 0x17, 0xa6, 0xba, 0xc6, 0xc6, 0x97,
	0xe7, 0x7d, 0x36, 0x96, 0xd8, 0xb8, 0x6f, 0x5a, 0xe6, 0x85, 0xa9, 0x96, 0x90, 0x02, 0x35, 0xf3,
	0xd4, 0xe8, 0x5a, 0x66, 0x5f, 0x2d, 0xa3, 0x75, 0xa8, 0xf7, 0x5f, 0x38, 0xb1, 0x55, 0x61, 0x77,
	0xd9, 0x09, 0xa6, 0x42, 0x96, 0xd3, 0xbb, 0xec, 0x0c, 0x76, 0x96, 0x1d, 0xc9, 0x5d, 0xf6, 0x3c,
	0xd7, 0x19, 0x3c, 0x01, 0x4a, 0x26, 0x7b, 0x71, 0x86, 0xc8, 0xd3, 0x1f, 0xc1, 0x56, 0xd2, 0x05,
	0x0e, 0x75, 0xe9, 0xe2, 0xce, 0xfc, 0x43, 0x5a, 0x5c, 0x34, 0x09, 0x9e, 0xfc, 0xe6, 0x6b, 0xa8,
	0x72, 0x40, 0x93, 0xb8, 0x22, 0x3e, 0x5f, 0xea, 0xab, 0x1c, 0xb9, 0xcd, 0xad, 0x58, 0x0b, 0xf1,
	0xac, 0xe6, 0x31, 0x40, 0x06, 0x7e, 0x50, 0xb5, 0xf7, 0xa0, 0x79, 0x82, 0x69, 0x96, 0xf9, 0x7c,
	0x5e, 0x5e, 0xc1, 0xe3, 0x42, 0x6f, 0xb2, 0xea, 0x8e, 0x78, 0x67, 0x27, 0xb9, 0x29, 0xaa, 0xa6,
	0xc0, 0x3a, 0x18, 0xe6, 0xce, 0x11, 0xd4, 0x80, 0xaa, 0x75, 0xd6, 0x33, 0x2c, 0x75, 0x0d, 0xc9,
	0x50, 0x72, 0x9e, 0xa9, 0x12, 0xaa, 0x41, 0xd9, 0x19, 0x74, 0xd5, 0x12, 0xf3, 0xf5, 0x4c, 0xcb,
	0x72, 0xd4, 0x0a, 0x1b, 0x1a, 0x3f, 0x5e, 0xda, 0xa6, 0x5a, 0x65, 0xee, 0x93, 0x9e, 0xa3, 0xca,
	0x8c, 0xdf, 0xed, 0xa8, 0x35, 0xe6, 0x1b, 0x18, 0xa7, 0x17, 0x86, 0x5a, 0xe7, 0x53, 0x5f, 0x18,
	0x6a, 0xe3, 0xe0, 0xdb, 0xe5, 0x2b, 0x81, 0x07, 0xb3, 0x4c, 0xc3, 0x8e, 0x95, 0x33, 0x30, 0x9c,
	0x0b, 0xd3, 0x56, 0x25, 0x54, 0x87, 0xca, 0xa5, 0x63, 0xda, 0x6a, 0x89, 0x49, 0x85, 0x8d, 0x7e,
	0x3e, 0x7f, 0xdd, 0x57, 0xcb, 0x9d, 0x3f, 0x25, 0xd8, 0x4c, 0xee, 0xb5, 0xf4, 0x30, 0x40, 0xaf,
	0x60, 0x23, 0xaf, 0x12, 0xf4, 0x71, 0xba, 0xd9, 0x42, 0x59, 0x35, 0x3f, 0x59, 0xe5, 0x8e, 0xf3,
	0xa7, 0xaf, 0xa1, 0x97, 0xb0, 0x2e, 0x96, 0x18, 0x3d, 0x2e, 0x2e, 0x7c, 0x1c, 0x6e, 0xef, 0x7d,
	0xaa, 0xd0, 0xd7, 0x3a, 0x33, 0x40, 0x42, 0x47, 0xa6, 0xab, 0x7e, 0x03, 0x5b, 0x05, 0x35, 0x44,
	0xba, 0xb0, 0xb6, 0x15, 0xe5, 0x6f, 0x3e, 0x79, 0x2f, 0x67, 0xf1, 0xdf, 0x77, 0xb0, 0x9b, 0x3e,
	0x02, 0xf9, 0x8b, 0x10, 0x87, 0x8b, 0x9f, 0xff, 0x04, 0xcd, 0xfc, 0x23, 0xb1, 0x8b, 0xdf, 0x92,
	0x10, 0xf7, 0xf1, 0x18, 0x53, 0x9c, 0xa5, 0xaf, 0xf0, 0x85, 0x99, 0xa5, 0xaf, 0xf8, 0x9d, 0xa9,
	0xaf, 0x5d, 0xc9, 0xfc, 0x8d, 0xfa, 0xec, 0xbf, 0x00, 0x00, 0x00, 0xff, 0xff, 0x47, 0xa3, 0x74,
	0x4a, 0xf3, 0x0a, 0x00, 0x00,
}
