/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _pydio = require('pydio');

var _pydio2 = _interopRequireDefault(_pydio);

var _Pydio$requireLib = _pydio2['default'].requireLib('hoc');

var EditorActions = _Pydio$requireLib.EditorActions;
var onToggleResolution = function onToggleResolution(_ref) {
  var dispatch = _ref.dispatch;
  var tab = _ref.tab;
  return function (high) {
    return dispatch(EditorActions.tabModify({ id: tab.id, resolution: high ? "hi" : "lo" }));
  };
};
exports.onToggleResolution = onToggleResolution;
var onSelectionChange = function onSelectionChange(_ref2) {
  var dispatch = _ref2.dispatch;
  var tab = _ref2.tab;
  return function (node) {
    return dispatch(EditorActions.tabModify({ id: tab.id, title: node.getLabel(), node: node }));
  };
};
exports.onSelectionChange = onSelectionChange;
var onTogglePlaying = function onTogglePlaying(_ref3) {
  var dispatch = _ref3.dispatch;
  var tab = _ref3.tab;
  return function (playing) {
    return dispatch(EditorActions.tabModify({ id: tab.id, playing: playing }));
  };
};
exports.onTogglePlaying = onTogglePlaying;
var onSizeChange = function onSizeChange(_ref4) {
  var dispatch = _ref4.dispatch;
  return function (data) {
    return dispatch(EditorActions.editorModify(data));
  };
};
exports.onSizeChange = onSizeChange;
