/**
 * Pydio Cells Rest API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _ApiClient = require("../ApiClient");

var _ApiClient2 = _interopRequireDefault(_ApiClient);

var _modelIdmWorkspace = require('../model/IdmWorkspace');

var _modelIdmWorkspace2 = _interopRequireDefault(_modelIdmWorkspace);

var _modelRestDeleteResponse = require('../model/RestDeleteResponse');

var _modelRestDeleteResponse2 = _interopRequireDefault(_modelRestDeleteResponse);

var _modelRestSearchWorkspaceRequest = require('../model/RestSearchWorkspaceRequest');

var _modelRestSearchWorkspaceRequest2 = _interopRequireDefault(_modelRestSearchWorkspaceRequest);

var _modelRestWorkspaceCollection = require('../model/RestWorkspaceCollection');

var _modelRestWorkspaceCollection2 = _interopRequireDefault(_modelRestWorkspaceCollection);

/**
* WorkspaceService service.
* @module api/WorkspaceServiceApi
* @version 1.0
*/

var WorkspaceServiceApi = (function () {

  /**
  * Constructs a new WorkspaceServiceApi. 
  * @alias module:api/WorkspaceServiceApi
  * @class
  * @param {module:ApiClient} apiClient Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */

  function WorkspaceServiceApi(apiClient) {
    _classCallCheck(this, WorkspaceServiceApi);

    this.apiClient = apiClient || _ApiClient2['default'].instance;
  }

  /**
   * Delete an existing workspace
   * @param {String} slug 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/RestDeleteResponse} and HTTP response
   */

  WorkspaceServiceApi.prototype.deleteWorkspaceWithHttpInfo = function deleteWorkspaceWithHttpInfo(slug) {
    var postBody = null;

    // verify the required parameter 'slug' is set
    if (slug === undefined || slug === null) {
      throw new Error("Missing the required parameter 'slug' when calling deleteWorkspace");
    }

    var pathParams = {
      'Slug': slug
    };
    var queryParams = {};
    var headerParams = {};
    var formParams = {};

    var authNames = [];
    var contentTypes = ['application/json'];
    var accepts = ['application/json'];
    var returnType = _modelRestDeleteResponse2['default'];

    return this.apiClient.callApi('/workspace/{Slug}', 'DELETE', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType);
  };

  /**
   * Delete an existing workspace
   * @param {String} slug 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/RestDeleteResponse}
   */

  WorkspaceServiceApi.prototype.deleteWorkspace = function deleteWorkspace(slug) {
    return this.deleteWorkspaceWithHttpInfo(slug).then(function (response_and_data) {
      return response_and_data.data;
    });
  };

  /**
   * Create or update a workspace
   * @param {String} slug 
   * @param {module:model/IdmWorkspace} body 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/IdmWorkspace} and HTTP response
   */

  WorkspaceServiceApi.prototype.putWorkspaceWithHttpInfo = function putWorkspaceWithHttpInfo(slug, body) {
    var postBody = body;

    // verify the required parameter 'slug' is set
    if (slug === undefined || slug === null) {
      throw new Error("Missing the required parameter 'slug' when calling putWorkspace");
    }

    // verify the required parameter 'body' is set
    if (body === undefined || body === null) {
      throw new Error("Missing the required parameter 'body' when calling putWorkspace");
    }

    var pathParams = {
      'Slug': slug
    };
    var queryParams = {};
    var headerParams = {};
    var formParams = {};

    var authNames = [];
    var contentTypes = ['application/json'];
    var accepts = ['application/json'];
    var returnType = _modelIdmWorkspace2['default'];

    return this.apiClient.callApi('/workspace/{Slug}', 'PUT', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType);
  };

  /**
   * Create or update a workspace
   * @param {String} slug 
   * @param {module:model/IdmWorkspace} body 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/IdmWorkspace}
   */

  WorkspaceServiceApi.prototype.putWorkspace = function putWorkspace(slug, body) {
    return this.putWorkspaceWithHttpInfo(slug, body).then(function (response_and_data) {
      return response_and_data.data;
    });
  };

  /**
   * Search workspaces on certain keys
   * @param {module:model/RestSearchWorkspaceRequest} body 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/RestWorkspaceCollection} and HTTP response
   */

  WorkspaceServiceApi.prototype.searchWorkspacesWithHttpInfo = function searchWorkspacesWithHttpInfo(body) {
    var postBody = body;

    // verify the required parameter 'body' is set
    if (body === undefined || body === null) {
      throw new Error("Missing the required parameter 'body' when calling searchWorkspaces");
    }

    var pathParams = {};
    var queryParams = {};
    var headerParams = {};
    var formParams = {};

    var authNames = [];
    var contentTypes = ['application/json'];
    var accepts = ['application/json'];
    var returnType = _modelRestWorkspaceCollection2['default'];

    return this.apiClient.callApi('/workspace', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType);
  };

  /**
   * Search workspaces on certain keys
   * @param {module:model/RestSearchWorkspaceRequest} body 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/RestWorkspaceCollection}
   */

  WorkspaceServiceApi.prototype.searchWorkspaces = function searchWorkspaces(body) {
    return this.searchWorkspacesWithHttpInfo(body).then(function (response_and_data) {
      return response_and_data.data;
    });
  };

  return WorkspaceServiceApi;
})();

exports['default'] = WorkspaceServiceApi;
module.exports = exports['default'];
