"use strict";

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require("material-ui");

var _TextField = require("./TextField");

var _TextField2 = _interopRequireDefault(_TextField);

var AltText = (function (_React$Component) {
    _inherits(AltText, _React$Component);

    function AltText() {
        _classCallCheck(this, AltText);

        _React$Component.apply(this, arguments);
    }

    AltText.prototype.render = function render() {
        var _props = this.props;
        var attributes = _props.attributes;
        var _props$altIcon = _props.altIcon;
        var altIcon = _props$altIcon === undefined ? "mdi mdi-toggle-switch" : _props$altIcon;
        var _props$altIconText = _props.altIconText;
        var altIconText = _props$altIconText === undefined ? "mdi mdi-textbox" : _props$altIconText;
        var _props$altTip = _props.altTip;
        var altTip = _props$altTip === undefined ? "Switch to text version" : _props$altTip;
        var onAltTextSwitch = _props.onAltTextSwitch;

        var comp = undefined;
        var alternativeText = attributes.alternativeText;

        if (alternativeText) {
            comp = _react2["default"].createElement(_TextField2["default"], this.props);
        } else {
            comp = this.props.children;
        }
        return _react2["default"].createElement(
            "div",
            { style: { display: 'flex' } },
            _react2["default"].createElement(
                "div",
                { style: { flex: 1 } },
                comp
            ),
            _react2["default"].createElement(
                "div",
                null,
                _react2["default"].createElement(_materialUi.IconButton, {
                    iconClassName: alternativeText ? altIcon : altIconText,
                    title: altTip,
                    onTouchTap: function () {
                        return onAltTextSwitch(attributes["name"], !alternativeText);
                    },
                    iconStyle: { opacity: .3, fontSize: 20 },
                    style: { padding: '14px 8px', width: 42, height: 42 }
                })
            )
        );
    };

    return AltText;
})(_react2["default"].Component);

exports["default"] = AltText;

var test = function test(Component) {
    var wrapped = (function (_React$Component2) {
        _inherits(wrapped, _React$Component2);

        function wrapped() {
            _classCallCheck(this, wrapped);

            _React$Component2.apply(this, arguments);
        }

        wrapped.prototype.render = function render() {
            var _props2 = this.props;
            var attributes = _props2.attributes;
            var _props2$altIcon = _props2.altIcon;
            var altIcon = _props2$altIcon === undefined ? "mdi mdi-toggle-switch" : _props2$altIcon;
            var _props2$altIconText = _props2.altIconText;
            var altIconText = _props2$altIconText === undefined ? "mdi mdi-textbox" : _props2$altIconText;
            var _props2$altTip = _props2.altTip;
            var altTip = _props2$altTip === undefined ? "Switch" : _props2$altTip;
            var onAltTextSwitch = _props2.onAltTextSwitch;

            var comp = undefined;
            var alternativeText = attributes.alternativeText;

            if (alternativeText) {
                comp = _react2["default"].createElement(_TextField2["default"], this.props);
            } else {
                comp = _react2["default"].createElement(Component, this.props);
            }
            return _react2["default"].createElement(
                "div",
                { style: { display: 'flex' } },
                _react2["default"].createElement(
                    "div",
                    { style: { flex: 1 } },
                    comp
                ),
                _react2["default"].createElement(
                    "div",
                    null,
                    _react2["default"].createElement(_materialUi.IconButton, {
                        iconClassName: alternativeText ? altIcon : altIconText,
                        tooltip: altTip,
                        onTouchTap: function () {
                            return onAltTextSwitch(attributes["name"], !alternativeText);
                        }
                    })
                )
            );
        };

        return wrapped;
    })(_react2["default"].Component);

    return wrapped;
};
module.exports = exports["default"];
