/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('material-ui');

var IconButton = _require.IconButton;

var _Pydio$requireLib = Pydio.requireLib('hoc');

var makeTransitionHOC = _Pydio$requireLib.makeTransitionHOC;
var withHideDisabled = _Pydio$requireLib.withHideDisabled;

// Display components

var _default = (function (_React$Component) {
    _inherits(_default, _React$Component);

    function _default() {
        _classCallCheck(this, _default2);

        _React$Component.apply(this, arguments);
    }

    _default.prototype.render = function render() {
        return React.createElement(IconButton, this.props);
    };

    var _default2 = _default;
    _default = makeTransitionHOC({ opacity: 0 }, { opacity: 1 })(_default) || _default;
    _default = withHideDisabled()(_default) || _default;
    return _default;
})(React.Component);

exports['default'] = _default;
module.exports = exports['default'];
