/**
 * Pydio Cells Rest API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import UpdateApplyUpdateRequest from '../model/UpdateApplyUpdateRequest';
import UpdateApplyUpdateResponse from '../model/UpdateApplyUpdateResponse';
import UpdateUpdateRequest from '../model/UpdateUpdateRequest';
import UpdateUpdateResponse from '../model/UpdateUpdateResponse';

/**
* UpdateService service.
* @module api/UpdateServiceApi
* @version 1.0
*/
export default class UpdateServiceApi {

    /**
    * Constructs a new UpdateServiceApi. 
    * @alias module:api/UpdateServiceApi
    * @class
    * @param {module:ApiClient} apiClient Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Apply an update to a given version
     * @param {String} targetVersion 
     * @param {module:model/UpdateApplyUpdateRequest} body 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/UpdateApplyUpdateResponse} and HTTP response
     */
    applyUpdateWithHttpInfo(targetVersion, body) {
      let postBody = body;

      // verify the required parameter 'targetVersion' is set
      if (targetVersion === undefined || targetVersion === null) {
        throw new Error("Missing the required parameter 'targetVersion' when calling applyUpdate");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling applyUpdate");
      }


      let pathParams = {
        'TargetVersion': targetVersion
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = UpdateApplyUpdateResponse;

      return this.apiClient.callApi(
        '/update/{TargetVersion}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Apply an update to a given version
     * @param {String} targetVersion 
     * @param {module:model/UpdateApplyUpdateRequest} body 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/UpdateApplyUpdateResponse}
     */
    applyUpdate(targetVersion, body) {
      return this.applyUpdateWithHttpInfo(targetVersion, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Check the remote server to see if there are available binaries
     * @param {module:model/UpdateUpdateRequest} body 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/UpdateUpdateResponse} and HTTP response
     */
    updateRequiredWithHttpInfo(body) {
      let postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateRequired");
      }


      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = UpdateUpdateResponse;

      return this.apiClient.callApi(
        '/update', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Check the remote server to see if there are available binaries
     * @param {module:model/UpdateUpdateRequest} body 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/UpdateUpdateResponse}
     */
    updateRequired(body) {
      return this.updateRequiredWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
