// Code generated by go-swagger; DO NOT EDIT.

package provisioning

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/pydio/pydio-sdk-go/models"
)

// NewAdminEditWorkspaceFeatureParams creates a new AdminEditWorkspaceFeatureParams object
// with the default values initialized.
func NewAdminEditWorkspaceFeatureParams() *AdminEditWorkspaceFeatureParams {
	var ()
	return &AdminEditWorkspaceFeatureParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAdminEditWorkspaceFeatureParamsWithTimeout creates a new AdminEditWorkspaceFeatureParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAdminEditWorkspaceFeatureParamsWithTimeout(timeout time.Duration) *AdminEditWorkspaceFeatureParams {
	var ()
	return &AdminEditWorkspaceFeatureParams{

		timeout: timeout,
	}
}

// NewAdminEditWorkspaceFeatureParamsWithContext creates a new AdminEditWorkspaceFeatureParams object
// with the default values initialized, and the ability to set a context for a request
func NewAdminEditWorkspaceFeatureParamsWithContext(ctx context.Context) *AdminEditWorkspaceFeatureParams {
	var ()
	return &AdminEditWorkspaceFeatureParams{

		Context: ctx,
	}
}

// NewAdminEditWorkspaceFeatureParamsWithHTTPClient creates a new AdminEditWorkspaceFeatureParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAdminEditWorkspaceFeatureParamsWithHTTPClient(client *http.Client) *AdminEditWorkspaceFeatureParams {
	var ()
	return &AdminEditWorkspaceFeatureParams{
		HTTPClient: client,
	}
}

/*AdminEditWorkspaceFeatureParams contains all the parameters to send to the API endpoint
for the admin edit workspace feature operation typically these are written to a http.Request
*/
type AdminEditWorkspaceFeatureParams struct {

	/*MetaID
	  plugin id for meta

	*/
	MetaID string
	/*Parameters
	  Meta source parameters

	*/
	Parameters models.MetaSourceParameters
	/*WorkspaceID
	  id or alias of this workspace

	*/
	WorkspaceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithTimeout(timeout time.Duration) *AdminEditWorkspaceFeatureParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithContext(ctx context.Context) *AdminEditWorkspaceFeatureParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithHTTPClient(client *http.Client) *AdminEditWorkspaceFeatureParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithMetaID adds the metaID to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithMetaID(metaID string) *AdminEditWorkspaceFeatureParams {
	o.SetMetaID(metaID)
	return o
}

// SetMetaID adds the metaId to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetMetaID(metaID string) {
	o.MetaID = metaID
}

// WithParameters adds the parameters to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithParameters(parameters models.MetaSourceParameters) *AdminEditWorkspaceFeatureParams {
	o.SetParameters(parameters)
	return o
}

// SetParameters adds the parameters to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetParameters(parameters models.MetaSourceParameters) {
	o.Parameters = parameters
}

// WithWorkspaceID adds the workspaceID to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) WithWorkspaceID(workspaceID string) *AdminEditWorkspaceFeatureParams {
	o.SetWorkspaceID(workspaceID)
	return o
}

// SetWorkspaceID adds the workspaceId to the admin edit workspace feature params
func (o *AdminEditWorkspaceFeatureParams) SetWorkspaceID(workspaceID string) {
	o.WorkspaceID = workspaceID
}

// WriteToRequest writes these params to a swagger request
func (o *AdminEditWorkspaceFeatureParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param metaId
	if err := r.SetPathParam("metaId", o.MetaID); err != nil {
		return err
	}

	if o.Parameters != nil {
		if err := r.SetBodyParam(o.Parameters); err != nil {
			return err
		}
	}

	// path param workspaceId
	if err := r.SetPathParam("workspaceId", o.WorkspaceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
